//+------------------------------------------------------------------+
//|                                                   HLine drag.mq5 |
//|                                           Copyright 2022, ernst. |
//|                                   https://www.mql5.com/en/pippod |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, ernst."
#property link      "https://www.mql5.com/en/pippod"
#property version   "1.00"
#property indicator_chart_window
#include<ChartObjects\ChartObjectsLines.mqh>
CChartObjectHLine line;
#include<ChartObjects\ChartObjectsArrows.mqh>
CChartObjectArrowRightPrice labl;
#include<ChartObjects\ChartObjectsTxtControls.mqh>
CChartObjectEdit edit;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- 
   line.Create(ChartID(),"line",0,0);
   line.Selectable(true);
   line.Selected(true);
   labl.Create(ChartID(),"labl",0,0,0);
   labl.Width(3);
   edit.Create(ChartID(),"edit",0,0,0,100,100);
   ChartSetInteger(ChartID(),CHART_SHIFT,true);
   ChartSetInteger(ChartID(),CHART_EVENT_MOUSE_MOVE,true);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   if(!prev_calculated) {
      line.Price(0,close[rates_total-1]);
      labl.Price(0,line.Price(0)); }
   if(rates_total!=prev_calculated)   
      labl.Time(0,time[rates_total-1]);
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   line.Delete();
   labl.Delete();
   edit.Delete();
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   if(sparam=="1" && id==CHARTEVENT_MOUSE_MOVE && labl.Price(0)!=line.Price(0)) {
      labl.Price(0,line.Price(0));
      edit.X_Distance((int)lparam);
      edit.Y_Distance((int)dparam); }
//---
  }
//+------------------------------------------------------------------+
